This is the Home of your awesome `python` projects' Documentation. 

# Projects

* [Example Project](/example_project) - Super project

# About

This Documentation has 2 layers:

* Each Python Project listed above has its own documentation, independantly generated _via_ [Sphinx](http://www.sphinx-doc.org/en/master/), especially thanks to `autodoc` which generates documentation from docstrings in the source code
</br></br>

* On top of these Project Documentations is the present Home Documentation which you are reading. It is generated by [Mkdocs](http://www.mkdocs.org) and is used to explore projects and store general, shared Documentation accross projects

To have these two layers work together, use `build.py` as documented below.



# How to Use

## mkdocs

    mkdocs.yml    # The configuration file for mkdocs.
    docs/
        index.md  # The documentation homepage (this one).
        ...       # Other markdown pages, images and other files.

## Adding a new project to the list

This procedure is independant from the presence of code in your project (_i.e._ whether or not it is already started or not yet). It is also independant from the presence of Documenation. See [Write Sphinx Documentation](documentation) for that matter. 

To list a new project in the *Projects* section:

1. Add it at the root of this Home Documentation (where `docs/` and `build.py` are)
2. Add a specific empty file to it : `touch my_awesome_project/__module__`
3. Mention it in this file's (`index.md`) [Projects](#projects) section as follows:
    * `* [My Project](/my_awesome_project) - My Project's short description`
    * `my_awesome_project` is the name of the folder your project is in

**`mkinx` tracks changes and modifications in `.md` or `.rst` files will automatically trigger a build and reload the server. Sweet!**

## Building the Documentations

Thanks to `build.py` you don't have to do much but `python build.py` with some flags:

```
$ python build.py -h

    usage: build.py [-h] [-v] [-A] [-F] [-o] [-p [PROJECTS [PROJECTS ...]]]

    Building Doc

    optional arguments:
    -h, --help            show this help message and exit
    -v, --verbose         verbose flag (Sphinx will stay verbose)
    -A, --all             Build doc for all projects
    -F, --force           force the build, no verification asked
    -o, --only_index      only build projects listed in the Documentation's Home
    -p [PROJECTS [PROJECTS ...]], --projects [PROJECTS [PROJECTS ...]]
                            list of projects to build
```

This script does 4 things:

1. Update mkdocs's `index.md` file with links to project documentations (_cf_ `~! `)
2. Build these documentations by running `make html` in the relevant projects (as per the `-p` or `-A` flags)
3. Update the documentations' `index.html` files to add a link back here
4. Build `mkdoc`'s home documentation, _i.e._ this very document

A couple examples:

* To build your new project's documentation but leave others untouched:
    * `python build.py -p my_awesome_project`
    * Obviously works to rebuild it every time it is updated
* To build documentations for all projects' listed in [Projects](#projects):
    * `python build.py -A -o`
    * There may be projects not listed above for any reason and you may not want to build their documentation
